############################################################
#Leitprogramm Kapitel 3: Datenformate
#
#
#K. Rosin (Oktober 2008)
############################################################


#-----------------------------------------------------------
#Kapitel 3.1: R als Taschenrechner
#-----------------------------------------------------------

#Operatoren
    3 * 4 - 2
    12 / 6
    2 ^ 4

    3 * 4 - 2
    3 * (4 - 2)

#Lsung zu bungsaufgabe 3.1
    (8 * 14) ^3 / 256
    (7 * (181 - 37) ^ 0.5) / 6


#-----------------------------------------------------------
#Kapitel 3.2: Objekte
#-----------------------------------------------------------

    a <- 5
    a <- 7
    A <- 1
    a
    A

#-----------------------------------------------------------
#Kapitel 3.3: Datentypen und Speichermodus
#-----------------------------------------------------------

#Datentyp testen
    mode(a)
    is.character(a)
    b <- is.character(a)
    b
    mode(b)

#Datentyp umwandeln
    b <- as.numeric(b)
    b

#Datentyp Faktor
    a <- factor(c("Kupfer", "Mangan", "Kupfer","Kupfer"))
    a
    mode(a)

#bungsaufgabe 3.2
    a <- 2.71828
    b <- a < 2
    c <- "Wasser"

#Lsung zu bungsaufgabe 3.2
    mode(a)
    mode(b)
    mode(c)
    b <- as.numeric(b)

#-----------------------------------------------------------
#Kapitel 3.4: Datenstrukturen
#-----------------------------------------------------------

#Vektoren
    Abfluss <- c(15.1, 7.8, 5.1, 3.3)
    Monat <- c("April", "Mai", "Juni", "Juli")
    Hochwasser <- c(T, F, F, F)

    mode(Abfluss)
    mode(Monat)
    mode(Hochwasser)

    #Replikationen
    a <- rep(2, 5)
    b <- rep("Sonntag", 5)
    c <- rep(TRUE, 3)

    #Sequenzen
    d <- seq(6, 11)
    d <- 6 : 11
    e <- seq(6, 24, by = 3)
    f <- seq(6, 24, length = 10)
    g <- seq(66, by=4, along = b)
    i <- seq(66, 78, along = b)
    j <- rev(i)

    #Rechnen mit Vektoren
    d
    d1 <- d + d
    d2 <- 3 * d
    d3 <- d1 * d2
    
    #bungsaufgabe 3.3
    test1 <- c(1, 8, 17, 25)
    test2 <- rep(1, 5)
    test3 <- seq(4, 10, by = 2)
    alle  <- c(test1, test3, test2)
    test4 <- c( seq(7,5) , rep("Phosphor", 3) )

    #Lsung zu bungsaufgabe 3.3
    rep( seq(9, 3, by = -2), 4)

#Matrizen
    I <- seq(4, 22, by = 2)
    J1 <- matrix(data = I, nrow = 5, ncol = 2, byrow = TRUE)
    J2 <- matrix(data = I, nrow = 5, ncol = 2, byrow = FALSE)
    J3 <- matrix(I, nrow= 5, byrow= TRUE)
    J4 <- matrix(seq(4, 22, by = 2), nrow= 5, byrow= TRUE)
    
    #Zeilen und Spalten anhngen
    K1 <- rbind(J4 , c(24, 26) )
    K2 <- cbind(J4 , rep(0, 5) )

    #Datentyp
    L1 <- matrix(c("Ammonium","Nitrat","Nitrit","Phosphat") ,nrow = 2)
    L2 <- cbind(L1 , c(20, 37) )
    mode(L1)
    mode(L2)
    
    #Rechnen mit Matrizen
    M1 <- matrix(seq(3, 25, length = 12), nrow = 3)
    M2 <- 2 * M1 - 1

    #bungsaufgabe 3.4
    N1 <- matrix( seq(3, by = 2, length = 9), nrow = 3, byrow = TRUE)
    
    #Lsung zu bungsaufgabe 3.4
    N2 <- matrix(rep(1:3, 4), nrow = 3)
    N2 <- matrix(rep(1:3, 4), nrow = 3, byrow = FALSE)
    N2 <- matrix(rep( c(1, 2, 3), 4), nrow = 3)
    N2 <- matrix(rep( seq(1, 3), 4), nrow = 3)
    
    N3 <- rbind(N2, rep(4, 4))
    N3 <- rbind(N2, c(4, 4, 4, 4))

#Dataframes
    Meteo <- data.frame( Mittlere_Temperatur = c (8.4, 9.3, 12.4, 14.1),
        Hauptwindrichtung = c("W", "WSW", "W", "NW") )
        
    names(Meteo) <- c("TEMP", "WIND")
    row.names(Meteo) <- c("Januar", "Februar", "Maerz", "April")
    Meteo
    
    dimnames(Meteo)

    #Lsung zu bungsaufgabe 3.5
    Bach <- data.frame ( Ba_Abfluss = c (2.1, 2.8, 2.9),
    Ba_Wochentag = c("Mo", "Di", "Mi") )
    Bach

#Listen
    Stationen <- list( Totalisatoren = c("Total1", "Total2", "Total3"),
        Jahresniederschlag = c(1050, 1102, 1274),
        Klimatuerme =c ("Klima1", "Klima2"),
        Globalstrahlung = c(851, 930) )

    Stationen$Globalstrahlung
    
    names(Stationen)
    

    
#-----------------------------------------------------------
#Kapitel 3.5: Datenimport und -export
#-----------------------------------------------------------

#Daten in R importieren
    MESS_PFAD <- "E:/Prop/R/temp/Messgroessen.csv"
    a <- read.table(MESS_PFAD, sep = ";", dec = ",", header = TRUE)

    a <- read.csv2(MESS_PFAD, dec = ",", header = TRUE)

#Daten aus R exportieren
    MESS_NEU <- "E:/Prop/R/temp/Messgroessen_Neu.csv"
    write.table(a, file = MESS_NEU, sep = ";", dec = ",", row.names= FALSE)

#Lsung zu bungsaufgabe 3.6
    KONZ_PFAD <- "E:/Prop/R/temp/Magnesium.csv"
    Konz1 <- read.table (KONZ_PFAD, sep = ";", dec = ",", header= TRUE)
    Konz2 <- Konz1 / 24305
    KONZ2_PFAD <- "E:/Prop/R/temp/Magnesium_Mol.csv"
    write.table(Konz2, file = KONZ2_PFAD, sep = ";", dec = ",", row.names = F)

