############################################################
#Leitprogramm Kapitel 4: Datenauswahl
#
#
#K. Rosin (Oktober 2008)
############################################################


#-----------------------------------------------------------
#Kapitel 4.1: Indizieren
#-----------------------------------------------------------

#Indizieren von Vektoren
    Abfluss <- c(15.1, 7.8, 5.1, 3.3)

    Abfluss[2]
    Abfluss[1:3]
    Abfluss[c(4,1)]
    Abfluss[-3]
    Abfluss[-c(1,3)]
    
    Fruehling <- Abfluss[-4]
    ob_Hochwasser <- Abfluss > 7
    Hochwasser1 <- Abfluss[ob_Hochwasser]
    Hochwasser1 <- Abfluss[Abfluss > 7]
    
    wo_Hochwasser <- which(Abfluss > 7)
    Hochwasser2 <- Abfluss[wo_Hochwasser]
    Hochwasser2 <- Abfluss[which( Abfluss > 7 )]
    
    Abfluss[wo_Hochwasser] <- 100
    
    #Lsungen zu bungsaufgabe 4.1
    A <- seq(16, 0, by = -2)
    B <- A[4:6] 
    #oder 
    B <- A [c(4, 5, 6)]
    C <- A[-3]

    ob_kleiner <- A < 10
    D1 <- A[ob_kleiner]
    #which-Funktion:
    wo_kleiner <- which(A < 10)
    D2 <- A[wo_kleiner]
    
    A[1:3] <- c(26, 34, 99)

#Indizieren von Matrizen
    M <- matrix(seq(5, by = 6, length = 12), nrow = 4, byrow = TRUE)

    M[4,2]
    M[3,]
    M[,2]
    M1 <- M[1:2,-2]
    
    #bungsaufgabe 4.2
    N <- matrix(seq(-50, by = 10, length = 9), nrow = 3, byrow = TRUE)

    #Lsungen zu bungsaufgabe 4.2
    N[2,1]
    N1 <- N [,-2]
    ob_negativ <- N < 0
    N3 <- N
    N3[ob_negativ] <- 0

#Indizieren von Listen
    Stationen <- list( Totalisatoren = c("Total1", "Total2", "Total3"),
        Jahresniederschlag = c(1050, 1102, 1274),
        Klimatuerme =c ("Klima1", "Klima2"),
        Globalstrahlung = c(851, 930) )

    names(Stationen)
    Stationen[[4]]
    Stationen[["Globalstrahlung"]]
    Stationen$Globalstrahlung
    
#Indizieren von Dataframes
    Meteo <- data.frame(TEMP = c (8.4, 9.3, 12.4, 14.1),
    		WIND = c("W", "WSW", "W", "NW"))
    names(Meteo)
    names(Meteo) <- c("Temperatur", "Windrichtung")

    #Indizieren wie Listen
    A <- Meteo$Temperatur[2:4]

    #Indizieren wie Matrizen
    A <- Meteo[2:4,1]
    A <- Meteo [2:4, "Temperatur"]
    
    #Lsungen zu bungsaufgabe 4.3
    Meteo$Windrichtung[4]
    Meteo[4,2]


#-----------------------------------------------------------
#Kapitel 4.2:	Datenabfragen
#-----------------------------------------------------------

    MESS_PFAD <- "E:/Prop/R/temp/Messgroessen.csv"
    Mess <- read.table(MESS_PFAD, sep =";", dec =",", header = T)
    names(Mess)
    head(Mess)

#Logische Abfrage
    ob_schwer <- Mess$Bezeichnung1 == "Schwermetalle"
    Schwermet <- Mess[ob_schwer,]

#Abfrage mit which-Funktion
    wo_schwer <- which(Mess$Bezeichnung1 == "Schwermetalle")
    Schwermet <- Mess [wo_schwer,]

    Schwermet1 <- Mess[ob_schwer, -c(6, 7)]
    Schwermet2 <- Mess[ob_schwer, c(2, 5, 3, 4)]

    ob_nicht_anorg <- Mess$Bezeichnung2 != "Anorganische Stoffe"
    Nicht_Anorg <- Mess[ob_nicht_anorg,]

#Verknpfte Abfragen
    ob_NP <- (Mess$Bezeichnung1 == "Stickstoff") | (Mess$Bezeichnung1 == "Phosphor")
    NP <- Mess[ob_NP,]

    ob_NDez <- (Mess$Bezeichnung1 == "Schwermetalle") &
        (Mess$Dezember_2004 >= Mess$Juli_2004)
    NDez <- Mess[ob_NDez,]

#bungsaufgabe 4.4
    A <- seq(37, by = 84, length = 14)

#Lsungen zu bungsaufgabe 4.4
    ob_groesser <- A > 500
    B <- A [ob_groesser]

    P_PFAD <- "E:/Prop/R/3_Daten/Phosphor_1996.csv"
    P <- read.table(P_PFAD,sep =";", dec=",", header=T)
    names(P)
    head(P)

    ob_punktuell <- P$Eintrag == "Punktuell"
    Punktuell <- P[ob_punktuell,]
    ob_nicht_punkt <- P$Eintrag != "Punktuell"
    Nicht_Punkt <- P[ob_nicht_punkt, c(1, 6, 2, 3)]
    ob_Eintrag1 <- (P$Schweiz >= 100) | (P$Deutschland >= 100)
    Eintrag1 <- P[ob_Eintrag1, 1:3]
    ob_Eintrag2 <- (P$Schweiz >= 100) & (P$Deutschland >= 100)
    Eintrag2 <- P[ob_Eintrag2, 1:3]


#-----------------------------------------------------------
#Kapitel 4.3:	Daten sortieren
#-----------------------------------------------------------

#sort-Funktion
    Sort1 <- sort(Mess$Abkuerzung)

#order-Funktion
    Reihe1 <- order(Mess$Bezeichnung1)
    Mess1  <- Mess[Reihe1,]

#rank-Funktion
    Rang1 <- rank(Mess$Bezeichnung1)
    data.frame(Werte = Mess$Bezeichnung1, Rang1 = Rang1)

#Kombinierte Abfragen
    Reihe2 <- order(Mess$Bezeichnung2, Mess$Bezeichnung1, Mess$Abkuerzung)
    Mess2  <- Mess[Reihe2,]

    Reihe3 <- order(Mess$Bezeichnung2, -Mess$Juli_2004)
    Mess3 <- Mess[Reihe3,]

    Reihe4 <- order(Mess$Bezeichnung2, -rank(Mess$Bezeichnung1))
    Mess4 <- Mess[Reihe4,]

#Lsungen zu bungsaufgabe
    ReiheP <- order(-rank(P$Eintrag), P$Herkunft)
    Phosphor_sort <- P[ReiheP,]
    Reihe_D <- order(-P$Deutschland)
    Phosphor_D <- P[Reihe_D,c(1,3)]


#-----------------------------------------------------------
#Kapitel 4.4: Datenstze vereinigen
#-----------------------------------------------------------

    ELEM_PFAD <- "E:/Prop/R/3_Daten/Elemente.csv"
    Elemente <- read.table(ELEM_PFAD, sep = ";", dec= ",", header = T)
        names(Elemente)
        head(Elemente)

    Mess_neu <- merge(Mess, Elemente, by.x = "Abkuerzung",
        by.y = "Symbol", all.x = F)

    Mess_neu2 <- merge(Mess, Elemente, by.x = "Abkuerzung",
        by.y = "Symbol", all.x = T)


#-----------------------------------------------------------
#Kapitel 4.5: Fehlende Werte
#-----------------------------------------------------------

    A <- c( 3, 8, NA, 2)
    5 * A
    A == 8

#Fehlende Werte identifizieren
    A == NA		#falsch
    is.na(A)  #richtig

#Fehlende Werte identifizieren
    mean(A)
    mean(A, na.rm = TRUE)

    B <- na.omit(A)
    A [is.na(A)] <- 0

#Symbole fr fehlende Werte
    B <- c(1, -9999, 7, -9999)
    ob_NA <- B == -9999
    B[ob_NA] <- NA
    mean(B, na.rm = TRUE)

#Fehlende Werte in Dataframes
    IO_PFAD <- "E:/Prop/R/3_Daten/Ionen_2004.csv"
    Ionen <- read.table(IO_PFAD, sep = ";", dec = ",", header = T)
    names(Ionen)
    head(Ionen)

    ob_NA <- is.na(Ionen)
    Ionen1 <- na.omit(Ionen)

#Lsungen zu bungsaufgabe 4.6
    V <- c(10, NA, 8, 15, NA)
    mean(V, na.rm = TRUE)
    is.na(V)
    G <- V
    G[is.na(G)] <- (-9999)
    H <- as.numeric(na.omit(V))

