############################################################
#Leitprogramm Kapitel 5: Berechnungen
#
#
#K. Rosin (Oktober 2008)
############################################################


#-----------------------------------------------------------
#Kapitel 5.1: Funktionen in R
#-----------------------------------------------------------

    A <- c(4, 6, 5, 9)
    mean(A)
    max(A)
    min(A)
    sum(A)
    prod(A)
    length(A)

    A1 <- c(4, 6, 5, 9)
    A2 <- c(-4, 0, -5, 9)
    A3 <- c(0.2, 6.5, 7.5, 4.8 )
    A4 <- c(0, pi/2, pi)
    A5 <- c(0.1, 0.6, -0.8)
    sqrt(A1)
    abs (A2)
    sign (A2)
    factorial(A1)

    round(A3)
    ceiling (A3)
    floor(A3)
    trunc(A3)
    exp(A1)
    exp(1)
    log(A1)
    log10(A1)
    log(A1, 10)
    sin(A4)
    cos(A4)
    tan(A4)
    asin(A5)
    acos(A5)
    atan(A5)

#bungsaufgabe 5.1
    A6 <- c(0.1, -1.5, 5.3)

#Lsungen zu bungsaufgabe 5.1
    mean(A6)
    exp(A6)
    sum(A6)
    max(A6)
    ceiling(A6)
    sqrt(abs(A6))


#-----------------------------------------------------------
#Kapitel 5.2: Eigene Funktionen
#-----------------------------------------------------------

    NeueFunktion1 <- function (x) {3*x + 15}

    NeueFunktion1(7)
    A <- c (-3, 4, 18)
    NeueFunktion1(A)

    Volumen <- function (L, B, H) {L * B * H}
    Volumen(7, 3, 8)
    Volumen(H = 8, L = 7, B = 3)

#Lsungen zu bungsaufgabe 5.2
    V_Abwasser <- function (l, r) { (pi*r^2) * l }
    V_Abwasser(200, 0.5)

#Kaufmnnisches Runden
    round1 <- function(x) {trunc(x+ sign(x)*0.5)}
    x1 <- seq(-3, 3, by=0.1)
    cbind(x1, round(x1), round1(x1))


#-----------------------------------------------------------
#Kapitel 5.3: Zeichenfolgen
#-----------------------------------------------------------

    A1 <- c("Ammonium", "Nitrat")
    toupper(A1)
    tolower(A1)
    nchar(A1)

    S1 <- substring(A1, 1, 3)
    S2 <- substring(A1, 2)
    S3 <- substring(A1, 1, 1)

    paste(S3, S2, sep ="_", collapse = NULL)
    paste(S3, S2, sep ="_", collapse = "#")

#bungsaufgabe 5.3
    Tage1 <- c("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag",
        "Freitag", "Samstag")
    
#Lsungen zu bungsaufgabe 5.3
    Tage2 <- substring(Tage1, 1, 2)
    Tage3 <- toupper(Tage2)
    Tage4 <- paste(1:30, "Juni", sep = ".", collapse = NULL)
    Tage5 <- paste(Tage3, Tage4, 2008, sep = " ", collapse = NULL)


#-----------------------------------------------------------
#Kapitel 5.4: Datum und Zeit
#-----------------------------------------------------------

#Input: Date
    BIRSIG_PFAD <- "E:/Prop/R/3_Daten/Birsig.csv"
    Bir <- read.table(BIRSIG_PFAD, sep = ";", dec = ",", header = T)
    names(Bir); dim(Bir)
    head(Bir)

    Messtag1 <- as.Date(Bir$Messtag, "%d.%m.%Y")
    class(Messtag1)

#Input: POSIXct
    LEI_PFAD <- "E:/Prop/R/3_Daten/Rheinfelden_Leitf.csv"
    Lei <- read.table(LEI_PFAD, sep = ";", dec = ",", header = T)
    names(Lei); dim(Lei)
    head(Lei)

    Zeit_Lei <- paste(Lei$Datum, Lei$Uhrzeit, sep = " ")

    Zeit_Lei1 <- as.POSIXct(strptime(Zeit_Lei, format="%d.%m.%Y %H:%M",
    		tz="GMT"), tz="GMT")
		
#Numerische Elemente (Date)
    Mess_Bir_num <- as.numeric(Messtag1)
    Mess_Bir_dat <- as.Date("1970-01-01") + Mess_Bir_num
		
#Numerische Elemente (POSIXct)
    Zeit_Lei_num <- as.numeric(Zeit_Lei1)
    Zeit_Lei_dat <- as.POSIXct("1970-01-01 00:00:00" , tz="GMT") + Zeit_Lei_num

#Berechnungen (Date)
    Messtag2 <- Messtag1 + 7
    Messtag1[4] > Messtag1[2]
    Diff_Mess_Bir1 <- Messtag1[2:25] - Messtag1[1:24]
    Diff_Mess_Bir2 <- as.numeric(Messtag1[2:25]) - as.numeric(Messtag1[1:24])

#Berechnungen (POSIXct)
    Zeit_Lei2 <- Zeit_Lei1+600
    Zeit_Lei1[5] > Zeit_Lei1[8]
    Diff_Zeit_Lei1 <- Zeit_Lei1[2:23] - Zeit_Lei1[1:22]
    Diff_Zeit_Lei2 <- as.numeric(Zeit_Lei1[2:23]) - as.numeric(Zeit_Lei1[1:22])

#Output (Date)
    Messtag_Neu <- format (Messtag2, "%d.%m.%Y")

#Output (POSIXct)
    Zeit_Lei_Neu <- format(Zeit_Lei2, "%d.%m.%Y %H:%M")

#Datum und Uhrzeit trennen
    Datum_Neu <- substring(Zeit_Lei_Neu, 1, 10)
    Uhrzeit_Neu <- substring(Zeit_Lei_Neu, 12)

#Lsungen zu bungsaufgabe 5.4
    DOC_PFAD <- "E:/Prop/R/3_Daten/DOC.csv"
    DOC <- read.table(DOC_PFAD, sep = ";", dec = ",", header = T)
    names(DOC); dim(DOC)
    head(DOC)

    Messtag1 <- as.Date(DOC$Messtag, "%d.%m.%Y")
    Messtag2 <- Messtag1 - 2
    Messtag3 <- Messtag2 > "2003-04-01"

#Lsungen zu bungsaufgabe 5.5
    PEG_PFAD <- "E:/Prop/R/3_Daten/Rheinfelden_Pegel.csv"
    Peg <- read.table(PEG_PFAD, sep = ";", dec = ",", header = T)
    names(Peg); dim(Peg)
    head(Peg)

    Zeit_Peg <- paste(Peg$Datum, Peg$Uhrzeit, sep = " ")
    Zeit_Peg1 <- as.POSIXct(strptime(Zeit_Peg, format="%d.%m.%Y %H:%M", tz="GMT"),
        tz="GMT")
    Zeit_Peg2 <- Zeit_Peg1 + 2*60
    Zeit_Peg3 <- format(Zeit_Peg2, "%d.%m.%Y %H:%M")

#Systemzeit
    t0 <- Sys.time()

    t1 <- Sys.time()
    t1 - t0


#-----------------------------------------------------------
#Kapitel 5.6: Schleifen
#-----------------------------------------------------------

#for Schleifen
    P <- c(1.2, 2.2, 0, 4.5, 0.5)

    P_kum <- rep(NA,5)  #initialisieren
    P_kum[1] <- P[1]
    for (i in 2:5) {P_kum[i] <- P_kum[i-1] + P[i]}
    cbind(P, P_kum)


#if Befehl
    P_cm <- rep(NA,5)  #initialisieren

    for (i in 1:5)
    {
        if (P[i] > 2) {P_cm[i] <- P[i]/10} else {P_cm[i] <- 0}
    }

#bungsaufgabe 5.6
    x_Meteo <- 550
    y_Meteo <- 358
    x_Total <- c(530, 517, 588, 650, 557)
    y_Total <- c(320, 366, 340, 380, 420)


#Lsungen zu bungsaufgabe 5.6
    Distanz <- rep(NA,5)
    for (i in 1:5)
    {
        Distanz[i] <- sqrt((x_Meteo -x_Total[i])^2 + (y_Meteo - y_Total [i])^2)
    }


#-----------------------------------------------------------
#Kapitel 5.7: Vektorwertig programmieren
#-----------------------------------------------------------

#Vektorwertige Operationen
    Distanz_Vektor <- sqrt((x_Meteo - x_Total)^2 + (y_Meteo - y_Total)^2)

#apply
    Sauer  <- matrix(c(15, 27, 20, 9, 11, 11, 0, 4, 3), 3, 3)
    Licht  <- apply(Sauer, 2, sum)
    Feucht <- apply(Sauer, 1, mean)

#tapply
    P_PFAD <- "E:/Prop/R/3_Daten/Phosphor_1996.csv"
    P <- read.table(P_PFAD, sep =";", dec=",", header=T)
    names(P); dim(P)
    head(P)

    tapply(P$Deutschland, P$Eintrag, sum)

#bungsaufgabe 5.7
    GRU_PFAD <- "E:/Prop/R/3_Daten/Grundwasser.csv"
    Gru <- read.table(GRU_PFAD, sep =";", dec=",", header=T)
    names(Gru); dim(Gru)
    head(Gru)

    tapply(Gru$Grundwasserstand, Gru$Monat, mean)

#ifelse
    P <- c(1.2, 2.2, 0, 4.5, 0.5)
    ob_P <- P > 2
    P_cm <- P * 0
    P_cm[ob_P] <- P[ob_P] / 10

    ifelse(P > 2, P_cm <- P, 0)
