############################################################
#Leitprogramm Kapitel 6: Berechnungen
#
#
#K. Rosin (Oktober 2008)
############################################################


#-----------------------------------------------------------
#Kapitel 6.1: Grafiken
#-----------------------------------------------------------

    O2_PFAD <- "E:/Prop/R/3_Daten/Weil_O2.csv"
    O2 <- read.table(O2_PFAD, sep = ";", dec = ",", header = T)
    names(O2); dim(O2)
    head(O2)

    options("device")

    plot(O2$Temp, O2$O2)

#jpg-Grafik
    TEMP_O2_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2.jpg"
    jpeg(TEMP_O2_PFAD, width = 600, height = 400)
        plot(O2$Temp, O2$O2)
    dev.off()

#Lsung zu bungsaufgabe 6.1
    ABFLUSS_O2_PFAD <- "E:/Prop/R/temp/Weil_Abfluss_O2.bmp"
    bmp(ABFLUSS_O2_PFAD, width = 600, height = 400)
        plot(O2$Abfluss, O2$O2)
    dev.off()

#Grafik verschnern
    TEMP_O2_1_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2_1.bmp"

    bmp(TEMP_O2_1_PFAD, width = 500, height = 500)
        plot(O2$Temp, O2$O2,
            main = "Sauerstoff und Temperatur",
            xlim = c(0,30), ylim = c(0,15),
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
            type = "p", pch = 24, col = "red", bg = "orange")
    dev.off()

#Grssenanpassung
    TEMP_O2_CEX2_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2_Cex2.bmp"
    bmp(TEMP_O2_CEX2_PFAD, width = 500, height = 500)
        par(cex = 2)
        plot(O2$Temp, O2$O2,
      			main = "Sauerstoff und Temperatur",
      			xlim = c(0,30), ylim = c(0,15),
      			xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
      			type = "p", pch = 24, col = "red", bg = "orange")
    dev.off()

    TEMP_O2_CEX2a_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2_Cex2a.bmp"
    bmp(TEMP_O2_CEX2a_PFAD, width = 500, height = 500)
        par(cex = 1, cex.main = 1, cex.axis = 0.8, cex.lab = 1.2, mex = 1.1)
        plot(O2$Temp, O2$O2,
      			main = "Sauerstoff und Temperatur",
      			xlim = c(0,30), ylim = c(0,15),
      			xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
      			type = "p", pch = 24, col = "red", bg = "orange")
    dev.off()

#Lsung zu bungsaufgabe 6.2
    TEMP_O2_CEX2b_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2_Cex2b.bmp"
    bmp(TEMP_O2_CEX2b_PFAD, width = 500, height = 500)
        par(cex = 1, cex.main = 1.6, cex.axis = 0.8, cex.lab = 1.2*0.8,
            mex = 1.1, font.main = 2, font.lab = 4)
        plot(O2$Temp, O2$O2,
      			main = "Sauerstoff und Temperatur",
      			xlim = c(0,30), ylim = c(0,15),
      			xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
      			type = "p", pch = 24, col = "red", bg = "orange")
    dev.off()

#Bildaufteilung
    TEMP_O2_Q_PFAD <- "E:/Prop/R/temp/Weil_Temp_O2_Abfluss.bmp"
    bmp(TEMP_O2_Q_PFAD, width = 1000, height = 500)
        par(mfrow = c(1,2), oma = c(1,0,2,0), mar = c(5.1,4.1,4.1,2.1))
        plot(O2$Temp, O2$O2, main = "Sauerstoff und Temperatur",
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
            pch = 17, col = "red")
        plot(O2$Temp, O2$Abfluss, main = "Abfluss und Temperatur",
            xlab = "Temperatur [C]", ylab = "Abfluss [m/s]",
            pch = 18, col = "blue")
    dev.off()

#points-Funktion
    TEMP_O2_P_PFAD <- "E:/Prop/R/temp/Weil_T_O2_nachJahr_p.bmp"
    bmp(TEMP_O2_P_PFAD, width = 500, height = 500)
        plot(O2$Temp[1:26], O2$O2[1:26],
            main = "Weil am Rhein", xlim = c(0,30), ylim = c(0,15),
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
            pch = 17, col = "blue")
        points (O2$Temp[27:51], O2$O2[27:51],
            pch = 18, col = "red", cex = 2)
    dev.off()

#Grsse der Punktzeichen
    TEMP_O2_P1_PFAD <- "E:/Prop/R/temp/Weil_T_O2_nachJahr_p1.bmp"
    bmp(TEMP_O2_P1_PFAD, width = 500, height = 500)
        plot(O2$Temp[1:26], O2$O2[1:26],
            main = "Weil am Rhein", xlim = c(0,30), ylim = c(0,15),
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]",
            pch = 17, col = "blue", type = "n")
        points (O2$Temp[27:51], O2$O2[27:51],
            pch = 18, col = "red", cex = 2)
        points (O2$Temp[1:26], O2$O2[1:26],
            pch = 17, col = "blue", cex = 1.6)
    dev.off()

#Legende
    TEMP_O2_LEG1_PFAD <- "E:/Prop/R/temp/Weil_T_O2_Legende1.bmp"
    bmp(TEMP_O2_LEG1_PFAD , width = 500, height = 500)
        plot(O2$Temp[1:26], O2$O2[1:26], main = "Weil am Rhein",
            xlim = c(0,30), ylim = c(0,15), pch = 17, col = "blue",
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]")
        points(O2$Temp[27:51], O2$O2[27:51], pch = 18, col = "red", cex = 2)
        legend(x = 25, y = 15, bty = "n", c("2003","2004"),
            col = c("blue","red"), pch = c(17,18), pt.cex = c(1,2))
    dev.off()

    TEMP_O2_LEG2_PFAD <- "E:/Prop/R/temp/Weil_T_O2_Legende2.bmp"
    bmp(TEMP_O2_LEG2_PFAD , width = 500, height = 500)
        plot(O2$Temp[1:26], O2$O2[1:26], main = "Weil am Rhein",
            xlim = c(0,30), ylim = c(0,15), pch = 17, col = "blue",
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]")
        points(O2$Temp[27:51], O2$O2[27:51], pch = 18, col = "red", cex = 2)
        legend("topright", bty = "n", c("2003","2004"), col = c("blue","red"),
            pch = c(17,18), pt.cex = c(1,2))
    dev.off()

#Linien
    TEMP_O2_LIN_PFAD <- "E:/Prop/R/temp/Weil_T_O2_Linien.bmp"
    bmp(TEMP_O2_LIN_PFAD, width = 500, height = 500)
        plot(O2$Temp[1:26], O2$O2[1:26], main = "Weil am Rhein",
            xlim = c(0,30), ylim = c(0,15), pch = 17, col = "blue",
            xlab = "Temperatur [C]", ylab = "Gelster Sauerstoff [mg/l]")
        points (O2$Temp[27:51], O2$O2[27:51],
            type = "l", lty = 2, lwd = 1.5, col = "magenta")
    dev.off()

#Lsung zu bungsaufgabe 6.3
    TEMP_Q_JAHR_PFAD <- "E:/Prop/R/temp/Weil_T_Q_Jahr.bmp"
    bmp(TEMP_Q_JAHR_PFAD, width = 500, height = 500)
        plot(O2$Temp, O2$Abfluss,
            main = "Weil am Rhein", xlim = c(0, 30), ylim = c(0, 2000),
            xlab = "Temperatur [C]", ylab = "Abfluss [m/s]", type = "n")
        points(O2$Temp[1:26], O2$Abfluss[1:26],
            pch = 1, col = "brown", cex = 2)
        points(O2$Temp[27:51], O2$Abfluss[27:51],
            pch = 4, col = "darkgreen", cex = 1.5)
        legend("topright", bty = "n", c("2003","2004"),
            col = c("brown","darkgreen"), pch = c(1,4), pt.cex = c(2,1.5))
    dev.off()

#Logarithmische Achsen
    TEMP_Q_YLOG_PFAD <- "E:/Prop/R/temp/Weil_T_Q_ylog.bmp"
    bmp(TEMP_Q_YLOG_PFAD, width = 500, height = 500)
        plot(O2$Temp, O2$Abfluss, log = "y", main = "Weil am Rhein",
            xlab = "Temperatur [C]", ylab = "Abfluss [m/s]", type = "n")
        points (O2$Temp[1:26], O2$Abfluss[1:26],
            pch = 1, col = "brown", cex = 2)
        points (O2$Temp[27:51], O2$Abfluss[27:51],
            pch = 4, col = "darkgreen", cex = 1.5)
        legend("topright", bty = "n", c("2003","2004"),
            col = c("brown","darkgreen"), pch = c(1,4), pt.cex = c(2,1.5))
    dev.off()


#-----------------------------------------------------------
#Kapitel 6.2: Analyse einer Datenreihe
#-----------------------------------------------------------

    NASS_PFAD <- "E:/Prop/R/3_Daten/Nass_River.csv"
    Nass <- read.table(NASS_PFAD, sep = ";", dec = ",", header = T)
    names(Nass); dim(Nass)
    Nass[1:10,]

    mean(Nass$Abfluss)
    median(Nass$Abfluss)
    sd(Nass$Abfluss)
    var(Nass$Abfluss)
    min(Nass$Abfluss); max(Nass$Abfluss)
    range(Nass$Abfluss)
    quantile(Nass$Abfluss, probs = c(0.01, 0.25, 0.5, 0.75, 0.99))
    summary(Nass$Abfluss)

#L-Momente
    install.packages("Lmoments")
    require(Lmoments)
    Lmoments(Nass$Abfluss, rmax=4)

#Index Grafik
    INDEX_PFAD <- "E:/Prop/R/temp/Index_Grafik.bmp"
    bmp(INDEX_PFAD, width = 500, height = 500)
    		plot(Nass$Abfluss)
    dev.off()

#Empirische Verteilung
    n <- length(Nass$Abfluss)
    Femp <- 1:n/(n+1)

    FEMP_PFAD <- "E:/Prop/R/temp/Empirische_Verteilung.bmp"
    bmp(FEMP_PFAD, width = 500, height = 500)
        plot(sort(Nass$Abfluss), Femp, main = "Nass River",
            xlim = c( 0, 6000 ), ylim = c( 0, 1 ), xlab = "Abfluss [m/s]",
            ylab = "Femp [-]", type = "s", col = "red")
    dev.off()

    quantile(Nass$Abfluss, probs = c(0.5, 0.9))


#Histogramm
    HIST1_PFAD <- "E:/Prop/R/temp/Nass_Histogramm1.bmp"
    bmp(HIST1_PFAD, width = 500, height = 500)
        hist(Nass$Abfluss)
    dev.off()

    HIST2_PFAD <- "E:/Prop/R/temp/Nass_Histogramm2.bmp"
    bmp(HIST2_PFAD, width = 500, height = 500)
        par(mar = c(5.1,4.1,1.5,1.5))
        hist(Nass$Abfluss, main = "Nass River", breaks = seq(0,6000,500),
            xlim = c(0,6000), ylim = c(0,12), col = "red",
            xlab = "Abfluss[m/s]", ylab = "Hufigkeit[-]")
    dev.off()

    VIER_HIST_PFAD <- "E:/Prop/R/temp/Nass_4_Histogramme.bmp"
    bmp(VIER_HIST_PFAD, width = 700, height = 700)
        par(mfrow = c(2,2), mar = c(5.1, 4.1, 1.5, 1.5), cex = 1.3)
        hist(Nass$Abfluss, main = "Klassenbreite = 1000",
            breaks = seq(0,6000,1000), xlim = c(0,6000), ylim = c(0,25),
            xlab = "Abfluss [m/s]", ylab = "Hufigkeit [-]", col = "red")
        hist(Nass$Abfluss, main = "Klassenbreite = 500",
            breaks = seq(0,6000,500), xlim = c(0,6000), ylim = c(0,25),
            xlab = "Abfluss [m/s]", ylab = "Hufigkeit [-]", col = "red")
        hist(Nass$Abfluss, main = "Klassenbreite = 250",
            breaks = seq(0,6000,250), xlim = c(0,6000), ylim = c(0,25),
            xlab = "Abfluss [m/s]", ylab = "Hufigkeit [-]", col = "red")
        hist(Nass$Abfluss, main = "Klassenbreite = 100",
        breaks = seq(0,6000,100), xlim = c(0,6000), ylim = c(0,25),
        xlab = "Abfluss [m/s]", ylab = "Hufigkeit [-]", col = "red")
    dev.off()

#Boxplots
    BOX1_PFAD <- "E:/Prop/R/temp/Nass_Boxplot1.bmp"
    bmp(BOX1_PFAD, width = 300, height = 500)
        boxplot(Nass$Abfluss)
    dev.off()

    BOX2_PFAD <- "E:/Prop/R/temp/Nass_Boxplot2.bmp"
    bmp(BOX2_PFAD, width = 300, height = 500)
    		par(mar = c(1.5, 4.1, 1.5, 1.5))
    		boxplot(Nass$Abfluss, horizontal = F,
    		    ylim = c(0,6000), ylab = "Abfluss [m/s]")
    dev.off()

    BOX3_PFAD <- "E:/Prop/R/temp/Nass_Boxplot3.bmp"
    bmp(BOX3_PFAD, width = 500, height = 300)
    		par(mar = c(5.1, 1.5, 1.5, 1.5))
    		boxplot(Nass$Abfluss, horizontal = T,
    			ylim = c(0,6000), xlab = "Abfluss [m/s]")
    dev.off()


#-----------------------------------------------------------
#Kapitel 6.3: Analyse einer Datenreihe mit Faktoren
#-----------------------------------------------------------

    P_PFAD <- "E:/Prop/R/3_Daten/Phosphor_1996.csv"
    P <- read.table(P_PFAD, sep =";", dec=",", header=T)
    names(P); dim(P)
    head(P)

#Vorbereitung mit der tapply Funktion
    P_CH_Summe <- tapply(P$Schweiz, P$Eintrag, sum)
    P_CH_Quantile <- tapply(P$Schweiz, P$Eintrag, quantile)

#Kuchendiagramme
    P_CH_KUCHEN_PFAD <- "E:/Prop/R/temp/P_CH_Kuchen.bmp"
        bmp(P_CH_KUCHEN_PFAD, width=500, height=500)
        pie(P_CH_Summe, main = "P-Eintrag der Schweiz", radius = 0.8,
            labels = names(P_CH_Summe), col = c("brown","green","orange"))
    dev.off()

#Lsung zu bungsaufgabe 6.5
    P_CH_Summe <- tapply(P$Schweiz, P$Eintrag, sum)
    P_D_Summe  <- tapply(P$Deutschland, P$Eintrag, sum)

    P_CH_D_KUCHEN_PFAD <- "E:/Prop/R/temp/P_CH_D_Kuchen.bmp"
        bmp(P_CH_D_KUCHEN_PFAD,width=600,height=300)
        par(mfrow = c(1,2), mar = c(3.5,3.5,3.5,3.5))
        pie(P_CH_Summe, main = "Schweiz", labels = names(P_CH_Summe),
            col = c("brown","green","orange"), radius = 1)
        pie(P_D_Summe,
        main = "Deutschland", labels = names(P_D_Summe),
            col = c("brown","green","orange"), radius = 1)
    dev.off()


#-----------------------------------------------------------
#Kapitel 6.4: Vergleich zweier Datenreihen
#-----------------------------------------------------------

#Korrelationskoeffizienten
    cor(O2$O2,O2$Temp)

    O2_Neu <- data.frame(O2[,-(1:2)])
    cor(O2_Neu)

#Darstellung von Zeitreihen (Date)
    W_Datum1 <- paste(O2$Datum, O2$Jahr, sep = "")
    W_Datum2 <- as.Date(W_Datum1, "%d.%m.%Y")

    Beginn <- as.Date("1.1.2003", "%d.%m.%Y")
    Ende   <- as.Date("1.1.2005", "%d.%m.%Y")
    #Beginn <- min(W_Datum2)
    #Ende   <- max(W_Datum2)

    W_T_DATUM_PFAD <- "E:/Prop/R/temp/W_T_Datum.bmp"
    bmp(W_T_DATUM_PFAD, width = 500, height = 500)
        plot(W_Datum2, O2$Temp, xaxt="n", type = "b")
        axis.Date(1, at = seq(Beginn, Ende, "years"), format = "%d.%m.%y")
    dev.off()

    W_T_DATUM1_PFAD <- "E:/Prop/R/temp/W_T_Datum1.bmp"
    bmp(W_T_DATUM1_PFAD, width = 500, height = 500)
        plot(W_Datum2, O2$Temp, xaxt="n", type = "l", lwd = 2,
            col = "navy", ylab = "Temperatur [C]")
        points(W_Datum2, O2$Temp, type = "p", pch = 16,
            col = "navy", cex = 0.7)
        axis.Date(1, at=seq(Beginn, Ende, "years"), tcl = -0.5, labels = F)
        axis.Date(1, at=seq(Beginn, Ende, "months"), tcl = -0.2, labels = F)
        axis.Date(1, at=seq(Beginn+365/2, Ende-366/2, "years"), tcl = 0,
            labels = T, format = "%Y")
    dev.off()

#Darstellung von Zeitreihen (POSIXct)
    RH_T_PFAD <- "E:/Prop/R/3_Daten/Rheinfelden_Temp2.csv"
    Rh <- read.table(RH_T_PFAD, sep = ";", dec = ",", header = T)
    names(Rh); dim(Rh)
    head(Rh)

    Rhein_Zeit1 <- paste(Rh$Datum, Rh$Uhrzeit, sep = " ")
    Rhein_Zeit2 <- as.POSIXct(strptime( Rhein_Zeit1, format =
        "%d.%m.%Y %H:%M", tz="GMT"), tz="GMT")

    Beginn <- min(Rhein_Zeit2)
    Ende   <- max(Rhein_Zeit2)

    TEMP_ZEIT_PFAD <- "E:/Prop/R/temp/Rhein_Temp_Zeit.bmp"
    bmp(TEMP_ZEIT_PFAD, width = 500, height = 500)
        plot(Rhein_Zeit2, Rh$Temp, xaxt="n", type = "b")
        axis.POSIXct(1, at = seq(Beginn, Ende, "days"),
            format = "%d.%m. %H:%M")
    dev.off()

    TEMP_ZEIT1_PFAD <- "E:/Prop/R/temp/Rhein_Temp_Zeit1.bmp"
    bmp(TEMP_ZEIT1_PFAD, width = 600, height = 400)
        plot(Rhein_Zeit2, Rh$Temp, xaxt="n", type = "l",
            ylab = "Temperatur [C]", lwd = 2, col = "aquamarine")
        points(Rhein_Zeit2, Rh$Temp, type = "p", pch = 16,
            col = "aquamarine", cex = 0.7)
        axis.POSIXct(1, at=seq(Beginn, Ende+3600, "days"),
            tcl = -0.5, labels = F)
        axis.POSIXct(1, at=seq(Beginn, Ende, 3600), #oder "hours"
            tcl = -0.2, labels = F)
        axis.POSIXct(1, at=seq(Beginn+(3600*24)/2, Ende+(3600*24)/2,
            "days"), tcl = 0, labels = T, format = "%d.%m.%y")
    dev.off()

#Lsung zu bungsaufgabe 6.6
    LI_PFAD <- "E:/Prop/R/3_Daten/Lindau_Pegel.csv"
    Li <- read.table(LI_PFAD, sep = ";", dec = ",", header = T)
    names(Li); dim(Li)
    head(Li)

    Li_Zeit1 <- paste(Li$Datum, Li$Uhrzeit, sep = " ")
    Li_Zeit2  <- as.POSIXct( strptime( Li_Zeit1 , format =
        "%d.%m.%Y %H:%M", tz="GMT"),tz="GMT")

    Beginn <- min(Li_Zeit2)
    Ende   <- max(Li_Zeit2)

    LIN_PFAD <- "E:/Prop/R/temp/Lindau_Pegel_Zeit.bmp"
    bmp(LIN_PFAD, width = 500, height = 500)
        plot(Li_Zeit2, Li$Pegel, xaxt="n", type = "l")
        axis.POSIXct(1, at=seq(Beginn, Ende, "days"),
            format = "%d.%m. %H:%M")
    dev.off()




